var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { FilesystemDirectory, WebPlugin, } from "@capacitor/core";
export class FilesystemPluginElectronExtendedWeb extends WebPlugin {
    constructor() {
        super({
            name: "FilesystemPluginElectronExtended",
            platforms: ["electron"]
        });
        this.NodeFS = null;
        this.fileLocations = null;
        this.fileLocations = { DRIVE_ROOT: "", DOCUMENTS: "" };
        let path = require("path");
        let os = require("os");
        if (os.platform == "win32") {
            this.fileLocations["DRIVE_ROOT"] = process.cwd().split(path.sep)[0];
        }
        else {
            this.fileLocations["DRIVE_ROOT"] = "/";
        }
        this.fileLocations[FilesystemDirectory.Documents] = path.join(os.homedir(), `Documents`) + path.sep;
        this.NodeFS = require("fs");
    }
    echo(options) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("ECHO", options);
            return options;
        });
    }
    writeFile(options, arrayBuffer) {
        return new Promise((resolve, reject) => {
            if (Object.keys(this.fileLocations).indexOf(options.directory) === -1)
                reject(`${options.directory} is currently not supported in the Electron implementation.`);
            let lookupPath = this.fileLocations[options.directory] + options.path;
            this.NodeFS.writeFile(lookupPath, arrayBuffer, (err) => {
                if (err)
                    reject(err);
                resolve();
            });
        });
    }
}
const FilesystemPluginElectronExtended = new FilesystemPluginElectronExtendedWeb();
export { FilesystemPluginElectronExtended };
//# sourceMappingURL=web.js.map